--
--  File: c:\moraes\vhdl\aula11\SRC\aula11.VHD
--  created by Design Wizard: 05/25/98 20:31:42
--
library IEEE;
use IEEE.Std_Logic_1164.all;

package ex1 is		
	
    subtype regsize is std_logic_vector(3 downto 0);	
	procedure somaAB  (  signal A,B: in  regsize;   signal Cin: in STD_LOGIC;
                         signal S:   out regsize;   signal Cout:out STD_LOGIC);
end ex1;

package body ex1 is
 
    procedure somaAB  (  signal A,B:  in  regsize;  signal Cin:  in STD_LOGIC;
                         signal S:    out regsize;  signal Cout: out STD_LOGIC)
         is             
      variable carry : STD_LOGIC;
      begin	
		   for w in 0 to 3 loop
		        if w=0 then carry:=Cin;  end if;
				S(w) <= A(w) xor B(w) xor carry;
				carry := (A(w) and B(w)) or (A(w) and carry) or (B(w) and carry);
		   end loop;
		   Cout <= carry;
    end procedure somaAB;

end package body ex1;



library IEEE;
use IEEE.Std_Logic_1164.all;
use work.ex1.all;

entity exemplo is
end;

architecture a1 of exemplo is
	signal opA, opB, soma : regsize;
	signal clock, reset, cin, cout: std_logic;		
begin
  
    cin <= '0';
    somaAB( opA, opB, cin, soma, cout );

    process(reset, clock)
	   begin
	    if reset='1' then
	        opA<=(others=>'0');
	        opB<="0001";
	    elsif clock'event and clock='1' then
	        opA <= opB;
	        opB <= soma;
	    end if;
    end process;
   
    -- gera o clock e o reset --
    reset <= '1', '0' after 5ns; 
    process
	  begin
	    clock <= '1' after 10ns, '0' after 20ns;
	    wait for 20ns;
     end process;
     
end a1;    
