 
 --- exercio realizado em aula dia 22/10/1998
 --- fernando moraes
 
 --- estudem!
 
 
library IEEE;
use IEEE.std_logic_1164.all;

	entity teste is
		port( clock, reset, dir : in std_logic;  
		      entrada: in STD_LOGIC_VECTOR(3 downto 0) 
		    );
	end teste;

	architecture a1 of teste is
	
	   signal A, B, C, de_dentro, de_fora : STD_LOGIC_VECTOR(3 downto 0);
	   
	begin
		
		process (clock, reset)
	     begin
	     
	       if reset = '1' then     -- aqui gera os tres registradores
	
	        A <= "0000";       B <= "0000";    C <= "0000"; 
	        
		    elsif clock'event and clock='1' then
		  
		     if dir='1' then
			    A <= entrada;
			    B <= A;
			    C <= B;
			  else  
			    A <= B;
			    B <= C;
			    C <= entrada;
			  end if;
			
		     end if; 
		
		de_dentro <= B and C;	-- dentro do process
		
      end process;
      
     -- observar que a atribuicao de dentro do processo gera uma
     -- saida defasada, o que e'  errado
     
     -- correto :  (ja' ha'  umas simulacao disponivel em simuOK
     de_fora <= B and C; 
     
end a1;


---------------------------------------------------------------
-----  test_bench
---------------------------------------------------------------

library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_LOGIC_UNSIGNED.all;
	entity tb is
	end tb;

	architecture a2 of tb is
	
	component teste
	   	port( clock, reset, dir : in std_logic;  
		      entrada: in STD_LOGIC_VECTOR(3 downto 0) 
		    );
	end component;
	
	signal ck, dir, reset : std_logic;
	signal entr : STD_LOGIC_VECTOR(3 downto 0) ;
	
	begin
	
	   cont1:  teste port map(clock=>ck, reset=>reset, dir=>dir, entrada=>entr);
	   
	   reset <= '1', '0' after 10ns;
	   
	   dir <= '0', '1' after 40ns, '0' after 100ns, '1' after 160ns;
	   
	   -- gera a entrada
	   process(ck, reset)
	    begin
	     if reset = '1' then entr <= "0101";
	       elsif ck'event and ck='1' then
	          entr <= entr + "0001" ;
	        end if;
	   end process;
	   
	   -- gerador de clock
	   process
	    begin
	     ck <= '1', '0' after 10ns;
	     wait for 20ns;
	   end process;
	    
	end a2;

